#
#	File:		ListEx2Part.make
#
#	Contains:	Makefile for OpenDoc ListEx2Part viewer
#
#	Written by:	Steve Smith
#
#	Copyright:	 1994-1995 by Apple Computer, Inc., all rights reserved.
#

#---------------------------------------------------------------------------	
# PROJECT VARIABLES
#---------------------------------------------------------------------------	

TargetName = ListEx2Part
TargetNameILink = {TargetName} (68k)
TargetNamePPCLink = {TargetName} (PPC)
TargetNameFat = {TargetName} (fat)

TargetCreatorType = "L"

BaseClassPath = {ListPartPath}

AdditionalIncludes = -i "{somSourceDir}" -i "{SourceDir}" -i "{BaseClassPath}_SOM_:"
AdditionalIDLIncludes = -i "{SourceDir}" -i "{BaseClassPath}_SOM_:" -i "{BaseClassPath}Source:"

#---------------------------------------------------------------------------	
# CFM/PEF Version Numbers
#---------------------------------------------------------------------------	
# For detailed instructions on proper CFM/PEF version numbering, see
# Code Fragment Chapter (pg 3-7), Inside Macintosh: PowerPC System Software
#---------------------------------------------------------------------------	

CurrentLibraryVersion =		0x01008000		# 1.0 Final
LibraryExportsVersion =		0x00000000		# 0.0
LibraryCodeVersion =		0x00000000		# 0.0

#---------------------------------------------------------------------------	
# DIRECTORY DEPENDENCIES
#---------------------------------------------------------------------------	

"{TargetDir}"   "{SourceDir}"
"{ObjectsDir}"  "{SourceDir}"
"{ObjectsDir}"  "{somSourceDir}"
"{ObjectsDir}"  "{ODUtilsImplDir}"

#---------------------------------------------------------------------------	
# ROOT TARGET
#---------------------------------------------------------------------------	

BUILDPPCLINK  
	"{CppPrecompiledHeaders}"				
	"{TargetDir}{TargetNamePPCLink}"		
	"{somSourceDir}som_ListEx2Part.exp"

BUILDREZ  
	"{ObjectsDir}{TargetName}.PPC.rsrc"		
	"{ObjectsDir}{TargetName}.68k.rsrc"

BUILDILINK  
	"{CppPrecompiledHeaders}"				
	"{TargetDir}{TargetNameILink}"			
	"{somSourceDir}som_ListEx2Part.exp"

BUILDIDL  
	"{somSourceDir}som_ListEx2Part.xih"		
	"{somSourceDir}som_ListEx2Part.xh"		
	"{somSourceDir}som_ListEx2Part.cpp"		
	"{somSourceDir}som_ListEx2Part.exp"
	

#---------------------------------------------------------------------------	
# FILE LIST VARIABLES
#---------------------------------------------------------------------------	

ListEx2PartOBJECTS = 
	"{ObjectsDir}ListEx2Part.cpp.o"			

somListEx2PartOBJECTS = 
	"{ObjectsDir}som_ListEx2PartInit.cpp.o"	
	"{ObjectsDir}som_ListEx2Part.cpp.o"		

OpenDocUtilityOBJECTS = 
	"{ObjectsDir}AltPoint.cpp.o" 			
	"{ObjectsDir}AltPoly.cpp.o" 			
	"{ObjectsDir}BndNSUtl.cpp.o" 			
	"{ObjectsDir}Crawl.cpp.o"	 			
	"{ObjectsDir}DocUtils.cpp.o"	 		
	"{ObjectsDir}Except.cpp.o" 				
	"{ObjectsDir}FocusLib.cpp.o" 			
	"{ObjectsDir}IText.cpp.o" 				
	"{ObjectsDir}FlipEnd.cpp.o" 			
	"{ObjectsDir}ISOStr.cpp.o" 				
	"{ObjectsDir}LinkList.cpp.o" 			
	"{ObjectsDir}NmSpcUtl.cpp.o" 			
	"{ObjectsDir}ODDebug.cpp.o" 			
	"{ObjectsDir}ODMemory.cpp.o"			
	"{ObjectsDir}ODNew.cpp.o"				
	"{ObjectsDir}ODUtils.cpp.o"				
	"{ObjectsDir}PasclStr.cpp.o"			
	"{ObjectsDir}PlfmFile.cpp.o" 			
	"{ObjectsDir}StorUtil.cpp.o"			
	"{ObjectsDir}StdTypIO.cpp.o"			
	"{ObjectsDir}TempIter.cpp.o"			
	"{ObjectsDir}TempObj.cpp.o"				
	"{ObjectsDir}UseRsrcM.cpp.o" 			
	"{ObjectsDir}WinUtils.cpp.o" 			
			
			
#---------------------------------------------------------------------------	
# DEPENDENCIES
#---------------------------------------------------------------------------	

# --- IDL ---

"{somSourceDir}"som_ListEx2Part.cpp 	
	"{somSourceDir}"som_ListEx2Part.idl	
	"{ODIDLIntfDir}"Part.idl
	
"{somSourceDir}"som_ListEx2Part.xih 	
	"{somSourceDir}"som_ListEx2Part.xh	
	"{somSourceDir}"som_ListEx2Part.idl	
	"{SourceDir}ListEx2PartVers.h"		
	"{ODIDLIntfDir}"Part.idl
	
"{somSourceDir}"som_ListEx2Part.xh 		
	"{somSourceDir}"som_ListEx2Part.idl	
	"{SourceDir}ListEx2PartVers.h"		
	"{ODIDLIntfDir}"Part.idl

# --- SOURCE ---

"{ObjectsDir}ListEx2Part.cpp.o"				
	"{CppPrecompiledHeaders}"				
	"{SourceDir}ListEx2Part.cpp" 			
	"{SourceDir}ListEx2Part.h" 				
	"{SourceDir}ListEx2PartDef.h"

# --- SOM OBJECTS ---

"{ObjectsDir}som_ListEx2Part.cpp.o"			
	"{CppPrecompiledHeaders}"				
	"{somSourceDir}som_ListEx2Part.cpp"		
	"{somSourceDir}som_ListEx2Part.xih"		
	"{SourceDir}ListEx2Part.h"

"{ObjectsDir}som_ListEx2PartInit.cpp.o"		
	"{CppPrecompiledHeaders}"				
	"{somSourceDir}som_ListEx2PartInit.cpp"	
	"{somSourceDir}som_ListEx2Part.xh"


#---------------------------------------------------------------------------	
# BUILD LIBRARIES
#---------------------------------------------------------------------------	

# --- 68k Link ---

"{TargetDir}{TargetNameILink}"  	 {ListEx2PartOBJECTS}			
									 {somListEx2PartOBJECTS}			
									 {OpenDocUtilityOBJECTS}		
									 "{somSourceDir}som_ListEx2Part.exp"
	Echo Linking: {TargetNameILink}
	{LinkTool}	
		-export `ConvertExportList "{somSourceDir}som_ListEx2Part.exp"` 
		{ILinkOptions}										
		{ILinkShLibOptions}									
		-init ListEx2PartCFMInit							
		-vercur {CurrentLibraryVersion}						
		-verdef {LibraryExportsVersion}						
		-verimp {LibraryCodeVersion}						
		{ShLibPreLibraries}									
		{ListEx2PartOBJECTS}								
		{somListEx2PartOBJECTS}								
		{OpenDocUtilityOBJECTS}								
		"{ODCFMLibrariesDir}OpenDoc Core.stub"				
		"{ODCFMLibrariesDir}OpenDoc User Interface.stub"	
		"{ODCFMLibrariesDir}OpenDoc Storage.stub"			
		"{ODCFMLibrariesDir}OpenDoc Imaging.stub"			
		"{ODCFMLibrariesDir}OpenDoc Layout.stub"			
		"{ODCFMLibrariesDir}Memory Manager.stub"			
		{ShLibPostLibraries}								
		"{BaseClassPath}ListPart (fat)"						
		-o "{ObjectsDir}{TargetNameILink}".seg
	If !{Status}
		Echo Building: {TargetNameILink}.SYM
		{SymTool} "{ObjectsDir}{TargetNameILink}".seg.NJ	
				-o "{TargetDir}{TargetNameILink}".SYM -sym 3.2
		Echo Building: {TargetNameILink}'s code/data fragment
		MakeFlat "{ObjectsDir}{TargetNameILink}".seg -o "{TargetDir}{TargetNameILink}"
		Echo Copying: {TargetNameILink}'s resources
		Echo "include "{RsrcObjectsDir}{TargetName}.68k.rsrc";" | Rez -a -o "{TargetDir}{TargetNameILink}"
		Echo "delete 'ckid';"  | Rez -a -o "{TargetDir}{TargetNameILink}"
		SetFile -a Bi -c "{TargetCreatorType}" {Targ}
	End

# --- PowerPC Link ---

"{TargetDir}{TargetNamePPCLink}" 		{ListEx2PartOBJECTS}			
										{somListEx2PartOBJECTS}		
										{OpenDocUtilityOBJECTS}		
										"{somSourceDir}som_ListEx2Part.exp"
	Echo Linking: {TargetNamePPCLink}
	{LinkTool}	
		-export `ConvertExportList "{somSourceDir}som_ListEx2Part.exp"` 
		{PPCLinkOptions}									
		{PPCLinkShLibOptions}								
		-init ListEx2PartCFMInit								
		-verCur {CurrentLibraryVersion}						
		-verDef {LibraryExportsVersion}						
		-verImp {LibraryCodeVersion}						
		{PPCShLibPreLibraries}								
		{ListEx2PartOBJECTS}								
		{somListEx2PartOBJECTS}								
		{OpenDocUtilityOBJECTS}								
		"{ODCFMLibrariesDir}OpenDoc Core.stub"				
		"{ODCFMLibrariesDir}OpenDoc User Interface.stub"	
		"{ODCFMLibrariesDir}OpenDoc Storage.stub"			
		"{ODCFMLibrariesDir}OpenDoc Imaging.stub"			
		"{ODCFMLibrariesDir}OpenDoc Layout.stub"			
		"{ODCFMLibrariesDir}Memory Manager.stub"			
		{PPCShLibPostLibraries}								
		"{BaseClassPath}ListPart (fat)"						
		-o "{ObjectsDir}{TargetNamePPCLink}"
	If !{Status}
		Move "{ObjectsDir}{TargetNamePPCLink}" "{TargetDir}"
		Echo Building: {TargetNamePPCLink}.xSYM
		{SymTool} "{ObjectsDir}{TargetNamePPCLink}".xcoff			
				{AdditionalIncludes} -i "{ODUtilsImplDir}"			
				-sym on,3.2 -o "{TargetDir}{TargetNamePPCLink}".xSYM
		Echo Copying: {TargetNamePPCLink}'s resources
		Echo "include "{RsrcObjectsDir}{TargetName}.PPC.rsrc";" | Rez -a -o "{TargetDir}{TargetNamePPCLink}"
		Echo "delete 'ckid';"  | Rez -a -o "{TargetDir}{TargetNamePPCLink}"
		SetFile -a Bi -c "{TargetCreatorType}" {Targ}
	End


#---------------------------------------------------------------------------	
# REZ STEPS
#---------------------------------------------------------------------------	

"{RsrcObjectsDir}{TargetName}.PPC.rsrc"									
										"{SourceDir}ListEx2Part.r"		
										"{SourceDir}ListEx2PartDef.h"	
										"{SourceDir}ListEx2PartVers.h"	
										"{SourceDir}ListEx2PartOtherResources.rsrc"
	Echo Rezzing: {TargetName}.r (for PPC)
	Rez {RezOptions} {ODRezIntf} "{SourceDir}{TargetName}.r" -o {targ}
	Echo "delete 'ckid';"  | Rez -a -o {Targ}
	SetFile -a i -c "{ResEditCreator}" -t "{ResEditFileType}" {Targ}
	if ( `exists "{TargetDir}{TargetNamePPCLink}" != ""` )
		Echo Copying: {TargetNamePPCLink}'s resources
		Echo "include ""{Targ}"";" | Rez -a -o "{TargetDir}{TargetNamePPCLink}"
	end	

"{RsrcObjectsDir}{TargetName}.68k.rsrc"									
										"{SourceDir}ListEx2Part.r"		
										"{SourceDir}ListEx2PartDef.h"	
										"{SourceDir}ListEx2PartVers.h"	
										"{SourceDir}ListEx2PartOtherResources.rsrc"
	Echo Rezzing: {TargetName}.r (for 68k)
	Rez -d _68KBUILD_ {RezOptions} {ODRezIntf} "{SourceDir}{TargetName}.r" -o {Targ} 
	Echo "delete 'ckid';"  | Rez -a -o {Targ}
	SetFile -a i -c "{ResEditCreator}" -t "{ResEditFileType}" {Targ}
	if ( `exists "{TargetDir}{TargetNameILink}" != ""` )
		Echo Copying: {TargetNameILink}'s resources
		Echo "include ""{Targ}"";" | Rez -a -o "{TargetDir}{TargetNameILink}"
	end


