
#ifndef _FOCUSLIB_
#include <FocusLib.h>
#endif

#ifndef _STORUTIL_
#include <StorUtil.h>
#endif

#ifndef _LISTEX2PART_
#include "ListEx2Part.h"
#endif

#ifndef _LISTEX2PARTDEF_
#include "ListEx2PartDef.h"
#endif

#ifndef _USERSRCM_
#include "UseRsrcM.h"
#endif

#ifndef SOM_ACF_DevServ3_som_ListEx2Part_xh
#include "som_ListEx2Part.xh"
#endif

ODISOStr ListEx2Part::GetTheRealPartKind(Environment* ev)
	{ return kListEx2PartKind; }

ODSLong ListEx2Part::OverrideBeginUsingLibraryResources(Environment* ev)
	{ return BeginUsingLibraryResources(); }

void ListEx2Part::OverrideEndUsingLibraryResources(Environment* ev, ODSLong ref)
	{ EndUsingLibraryResources(ref); }

void ListEx2Part::InitializeListData(Environment *ev,
		short* pNbLines,
		short* pLineHeight,
		short* pLineWidth,
		short* pLineDepth,
		short* pKind,
		short* pAutoThumb,
		short* pWantKey,
		short* pListIndex,
		short* pSel,
		char** pMul)
	{
	*pNbLines = NBLINES;
	*pLineHeight = 18;
	*pLineWidth = 400;
	*pLineDepth = 8;
	*pKind = 3;
	*pAutoThumb = 1;
	*pWantKey = 1;
	*pListIndex = 50;
	*pMul = 0L;
	
	for(short i=0; i<NBLINES; i++) ::NumToString(10001+i, &gBigTab[i][0]);
	}

void ListEx2Part::FillCell(Environment *ev, short theLine, Rect* theRect)
	{
	RGBColor myBlack = {0, 0, 0}, myLightGreen = {0xb000, 0xE000, 0xb000}, myLightRed = {0xE000, 0xb000, 0xb000};

	PenState thePnState;
	::GetPenState(&thePnState);
	::PenNormal();
	::EraseRect(theRect);
	::RGBForeColor(((theLine & 1) == 0)?(&myLightGreen):(&myLightRed));
	::PaintRect(theRect);
	::RGBForeColor(&myBlack);
	::MoveTo(theRect->left+24, theRect->bottom-3);
	::DrawString(gBigTab[theLine-1]);
	::SetPenState(&thePnState);
	}

void	ListEx2Part::FillHilCell(Environment* ev, short theLine, Rect* theRect)
	{
	FillCell(ev, theLine, theRect);
	::PenSize(3, 3);
	::MoveTo(theRect->left+3, theRect->top+1);
	::Line(14, 14);
	::MoveTo(theRect->left+3, theRect->top+15);
	::Line(14, -14);
	::PenSize(1, 1);
	}

void	ListEx2Part::ClickInActive(Environment* ev, ODFacet* facet, ODEventData* event, Rect* theRect)
	{
	CFocus lfoc(ev, facet);
	if (gListTE == 0L)
		{
		short whichLine = myself->GetSel(ev);
		theRect->left += 24;
		::FrameRect(theRect);
		::InsetRect(theRect,1,1);
		::TextFont(geneva);
		::TextSize(12);
		gListTE = ::TENew(theRect,theRect);
		::TESetText(&gBigTab[whichLine-1][1],gBigTab[whichLine-1][0],gListTE);
		::TECalText(gListTE);
		::TEUpdate(theRect, gListTE);
		::TEActivate(gListTE);
		}
	else
		{
		GlobalToLocal(&event->where);
		::TEClick(event->where,(event->modifiers & shiftKey),gListTE);
		}
	}

void	ListEx2Part::CloseOpenedCell(Environment* ev, ODFacet* facet)
	{
	CFocus lfoc(ev, facet);
	short whichLine = myself->GetSel(ev);
	short howMuch = (*gListTE)->teLength;
	if (howMuch > 15) howMuch = 15;
	::BlockMove((*((*gListTE)->hText)), &gBigTab[whichLine-1][1], howMuch);
	gBigTab[whichLine-1][0] = howMuch;
	::InsetRect(&(*gListTE)->destRect,-1,-1);
//	::InvalRect(&(*gListTE)->destRect);
	::TEDispose(gListTE);
	gListTE = 0L;
	}

void	ListEx2Part::IdleOpened(Environment* ev, ODFacet* facet)
	{
	CFocus lfoc(ev, facet);
	TEIdle(gListTE);
	}

short	ListEx2Part::KeyInActive(Environment* ev, ODFacet* facet, ODEventData* event)
	{
	CFocus lfoc(ev, facet);
	::TEKey(event->message & charCodeMask,gListTE);
	return(true);
	}

#define SUSV(prop,kind,len,addr) {											\
	ODSUForceFocus(ev, storageUnit, (prop), (kind));						\
	ODULong	oldSize = storageUnit->GetSize(ev);								\
	StorageUnitSetValue(storageUnit, ev, (len), (addr));					\
	ODULong newSize = storageUnit->GetOffset(ev);							\
	if (newSize < oldSize) storageUnit->DeleteValue(ev, oldSize - newSize); }

void	ListEx2Part::ExternalizeListData(Environment* ev, ODStorageUnit* storageUnit)
	{
	SUSV(kODPropListEx2Data, kListEx2Data, TABSIZE, gBigTab)
	}

#define SUGV(prop,kind,len,addr,msg) {										\
	if (ODSUExistsThenFocus(ev, storageUnit, (prop), (kind)))				\
		if ((theSize = storageUnit->GetSize(ev)) != len) DebugStr((msg));	\
		else StorageUnitGetValue(storageUnit, ev, (len), (addr));			}

void	ListEx2Part::InternalizeListData(Environment* ev, ODStorageUnit* storageUnit)
	{
	long theSize;

	SUGV(kODPropListEx2Data, kListEx2Data, TABSIZE, gBigTab, "\pStorage size for gBigTab is wrong !")
	}

#define APAV(prop,kind) {														\
	if ( !storageUnit->Exists(ev, (prop), kODNULL, 0) )							\
		storageUnit->AddProperty(ev, (prop));									\
	if ( !storageUnit->Exists(ev, (prop), (kind), 0) )							\
		{																		\
		storageUnit->Focus(ev, (prop), kODPosUndefined, kODNULL, 0, kODPosAll);	\
		storageUnit->AddValue(ev, (kind));										\
		}																		}

void	ListEx2Part::SetUpListData(Environment* ev, ODStorageUnit* storageUnit)
	{
	APAV(kODPropListEx2Data, kListEx2Data)
	}
