/*
	File:		ListEx3PartGlobals.h

	Contains:	ListEx3Part globals

	Written by:	Steve Smith

	Copyright:	 1995 by Apple Computer, Inc., all rights reserved.
*/


#ifndef _LISTEX3PARTGLOBALS_
#define _LISTEX3PARTGLOBALS_

// -- OpenDoc --

#ifndef _ODTYPES_
#include <ODTypes.h>
#endif

#ifndef SOM_Module_OpenDoc_StdDefs_defined
#include <StdDefs.h>
#endif

#ifndef _ITEXT_
#include <IText.h>
#endif

// -- MacToolbox --

#ifndef __TYPES__
#include <Types.h>
#endif

class ODMenuBar;
class ODFocusSet;


//==============================================================================
// Globals
//==============================================================================

struct ListEx3PartGlobals; // forward

extern	ODUShort			gGlobalsUsageCount;
extern	ListEx3PartGlobals*	gGlobals;


struct ListEx3PartGlobals {
	public:
	ListEx3PartGlobals();
	~ListEx3PartGlobals() {}
	
	ODMenuBar*		fMenuBar;
	ODFocusSet*		fUIFocusSet;	
	Handle			fThumbnail;
				
	ODTypeToken		fSelectionFocus;
	ODTypeToken		fMenuFocus;
	ODTypeToken		fModalFocus;
	ODTypeToken		fFrameView;
	ODTypeToken		fLargeIconView;
	ODTypeToken		fSmallIconView;
	ODTypeToken		fThumbnailView;
	ODTypeToken		fMainPresentation;
			
	ODScriptCode	fEditorsScript;
	ODLangCode		fEditorsLanguage;
};


inline ListEx3PartGlobals::ListEx3PartGlobals()
{
	fMenuBar		= kODNULL;
	fUIFocusSet		= kODNULL;	
	fThumbnail		= kODNULL;
				
	fSelectionFocus			= kODNullTypeToken;
	fMenuFocus				= kODNullTypeToken;
	fModalFocus				= kODNullTypeToken;
	fFrameView				= kODNullTypeToken;
	fLargeIconView			= kODNullTypeToken;
	fSmallIconView			= kODNullTypeToken;
	fThumbnailView			= kODNullTypeToken;
	fMainPresentation		= kODNullTypeToken;
			
	fEditorsScript		= 0;
	fEditorsLanguage	= 0;
}

#endif